               /*Ŀ
                                                                        
                  drawBspline() = draws a B-Spline Curve                
                                                                        
                 */

#include "gdraws.h"


void drawBspline(int segments, int color,...)
{
	#include <dos.h>
	#include <stdarg.h>
	#include <stdio.h>

	union REGS reg;

	va_list coord;
        int xpoint[20],ypoint[20],i=1,j,x,y,oldx,oldy,last;
	float u,nc1,nc2,nc3,nc4;

	va_start(coord,color);
	while (((xpoint[i]=va_arg(coord,int)) >= -320) &&
		((ypoint[i]=va_arg(coord,int)) >= -320) && (i<=20))
		i++;
	va_end(coord);
	xpoint[0]=xpoint[1];
	ypoint[0]=ypoint[1];
	oldx=xpoint[0];
	oldy=ypoint[0];
	for (j=i;j<=i+1;j++)
	{
		xpoint[j]=xpoint[j-1];
		ypoint[j]=ypoint[j-1];
	}
	last = j;
	for(i=1; i<=last-3; i++)
	{
		for (u=0; u<=1; u+=1.0/segments)
		{
			nc1=-(u*u*u/6)+u*u/2-u/2+1.0/6;
			nc2=u*u*u/2-u*u+2.0/3;
			nc3=(-u*u*u+u*u+u)/2+1.0/6;
			nc4=u*u*u/6;
			x = (nc1*xpoint[i-1]+nc2*xpoint[i]+nc3*xpoint[i+1]
				+nc4*xpoint[i+2]);
			y = (nc1*ypoint[i-1]+nc2*ypoint[i]+nc3*ypoint[i+1]
				+nc4*ypoint[i+2]);
			drawLine(oldx,oldy,x,y,color);
			oldx=x;
			oldy=y;
		}
	}
}


