
               /*Ŀ
                                                                        
                     readPixel() = Reads a pixel from the screen at     
                                   point (x,y) for Hercules Graphics    
                                   Card.                                
                                                                        
                 */

#include "gtools.h"

int readPixel(int x, int y)
{
	unsigned int offset;
        int page,pixel;
        char mask;
	char far *address;

        page = getPage();
        offset = 0x2000 * (y%4) + 0x8000 * page + 90 * (y/4) + x/8;
        mask = 0x80 >> (x%8);
	address = (char far *) 0xB0000000L + offset;
        pixel = *address & mask;
	if (pixel != 0) pixel = 1;
	return(pixel);
}


