               /*Ŀ
                                                                        
                  plots() = plots a point on the screen at designated   
                           system coordinates using selected color.     
                                                                        
                 */


#include "gdraws.h"

void plots(int x, int y, int color)    	/* plot pixel at x, y */
{
	#include <dos.h>

	#define seq_out(index,val)  {outp(0x3C4,index);\
					 outp(0x3C5,val);}
	#define graph_out(index,val)  {outp(0x3CE,index);\
					 outp(0x3CF,val);}

	unsigned int offset;
	int dummy,mask,page;
	char far * mem_address;

	convert(x,y);

	#ifdef CGA

	page = getPage();
	offset = 0x2000 * (y%2) + 0x4000 * page + 80 * (y/2) + x/4);
	mask = 0xC0   >> ((x%4)*2);
	mem_address = (char far *) 0xB8000000L + offset;
	*mem_address &= ~mask;
	mask = (color & 0x03) << (6 - (x%4 * 2);
	*mem_address |= mask;

	#endif

	#ifndef	CGA

	offset = (long)y * 80L + ((long)x / 8L);
	mem_address = (char far *) 0xA0000000L + offset;
	mask = 0x80 >> (x % 8);
	graph_out(8,mask);
	seq_out(2,0x0F);
	dummy = *mem_address;
	*mem_address = 0;
	seq_out(2,color);
	*mem_address = 0xFF;
	seq_out(2,0x0F);
	graph_out(3,0);
	graph_out(8,0xFF);

	#endif
}
